/**
 *  セントラル・リバシィ
 *  copyright  M.Shiojima
 *  2009-06-02 ver. 1.00
 */
function CentralRiversi() {
    this.TITLE = "セントラル・リバシィ";
    this.cell = null;
    this.color = 1;
    this.countList = null;
    this.gameEnd  = true;
    this.msgList = new Array();
    this.isCentralGame = true;
    this.bonusMode = false;
    this.COLOR1 = "red.gif";
    this.COLOR2 = "blue.gif";

    this.placeEnable = false;
    this.startPosList = new Array(new Position(310, 130), new Position(40,130));
    this.startGame = function() {
        var subwin = document.getElementById("subwin");
        subwin.style.display = "none";
        var googlead = document.getElementById("googlead");
        googlead.style.display = "none";
        this.isCentralGame = (document.forms.form0.gametype[0].checked);
        if (this.isCentralGame) {
            this.COLOR1 = "red.gif";
            this.COLOR2 = "blue.gif";
        } else {
            this.COLOR1 = "black.gif";
            this.COLOR2 = "white.gif";
        }
        this.placeEnable = true;


        this.initGame();
    }

    // 初期化
    this.init = function() {
        this.gameEnd = true;
        this.cell = new Array();
        this.color = 1;
        this.initKoma();
        this.dispCount();
        this.dispAllLink();
        this.dispMsg();
        this.infoIcon
            = new OpacityIcon(document.getElementById("ibutton"), "app.infoIcon");

        var e = document.getElementById("msg");
        e.style.display = "none";

        var plist = makePlacableList(this.color, this.cell);
        this.changePlacableColor(plist);
        animeCtrl.endHandler = "app.placeKomaHandler()";
    }

    this.initGame = function() {
        this.init();
        this.gameEnd = false;
    }

    this.isTsubuyaki = function() {
        return (document.forms.form0.tsubuyaki.checked);
    }
    
    this.animeTimes = function() {
    	if (isIPhone()) {
    		return 1;
    	}
    	return 10;
    }

    // 駒配置の初期化
    this.initKoma = function() {
        this.placeKoma("c44");
        this.color = (this.color % 2) + 1;
        this.placeKoma("c45");
        this.color = (this.color % 2) + 1;
        this.placeKoma("c55");
        this.color = (this.color % 2) + 1;
        this.placeKoma("c54");
        this.color = (this.color % 2) + 1;
    }

    // 駒をおくためのリンクの表示
    this.dispAllLink = function() {
        for (var y = 1; y <= 8; y++) {
            for (var x = 1; x <= 8; x++) {
                var id = makeId(x, y);
                if (!(this.cell[id]) ) {
                    e = document.getElementById(id);
                    if (e) {
                        e.innerHTML = "<a href='javascript:app.clickPlace(\""
                                + id + "\")' class='cell'>&nbsp;</a>";
                        e.style.fontSize = "16px";
                    }
                }
            }
        }
    }

    // location -> id 変換
    function makeId(x, y) {
        return "c" + String(x) + String(y);
    }

    // IDからLocationオブジェクトを生成
    function getLocationById(id) {
        x = parseInt(id.substring(1,2));
        y = parseInt(id.substring(2,3));
        return new Location(x, y);
    }


    // 駒を置く
    this.placeKoma = function(id, filpList) {
        this.cell[id] = this.color;

        var e = document.getElementById(id);
        if (e) {
            var c = (this.color == 1) ? this.COLOR1 : this.COLOR2;
            e.innerHTML = "<img onclick='app.clickPlace(\""
                    + id + "\")' src='" + c + "' class='cell'/>";
            e.style.fontSize = "16px";
            this.cell[id] = this.color;
            if (filpList) {
                for (i = 0; i < filpList.length; i++) {
                    id = filpList[i];
                    this.cell[id] = this.color;
                    e = document.getElementById(id);
                    if (e) {
                        e.innerHTML = "<img onclick='app.clickPlace(\""
                                + id + "\")' src='" + c
                                + "' class='cell'/>";
                        e.style.fontSize = "16px";
                    }
                }
            }
        }
    }

    // 中央占拠判定
    this.isCentralControl = function() {
        if (! this.isCentralGame) {
            return false;
        }
        for (x = 4; x <= 5; x++) {
            for (y = 4; y <= 5; y++) {
                var id = makeId(x, y);
                if (this.cell[id] != this.color) {
                    return false;
                }
            }
        }
        return true;
    }

    // ひっくり返しリストを作る
    function makeFlipList(id, c, cell) {
        var loc = getLocationById(id);
        var result = new Array();
        for (dir = 1;  dir <= 8; dir++) {
            var clist = new Array();
            var a = loc.getAjust(dir);
            var ac = null;
            while (a.isEnable() && (ac = cell[a.getId()]) ) {
                if (c == ac) {
                    break;
                } else {
                    clist.push(a.getId());
                }
                a =a.getAjust(dir);
            }
            if (a.isEnable() && (ac == c) ) {
                result = result.concat(clist);
            }
        }

        return result;
    }

    // 決定ボタン処理
    this.clickPlace = function(id) {
        if (! this.placeEnable) {
            return;
        }
        this.placeEnable = false;
        if (this.gameEnd) {
            this.restart();
            return;
        }
        var flipList = makeFlipList(id, this.color, this.cell);
        var targetColor = (this.color % 2) + 1;
        if (this.bonusMode && (this.cell[id] != targetColor) ) {
            this.addMsg("そこには置けませんよ");
        } else if ( (! this.bonusMode) && (this.cell[id]) ) {
            this.addMsg("そこには置けませんよ");
        } else if ( (!this.bonusMode) && (flipList.length == 0) ) {
            this.addMsg("そこには置けませんよ");
        } else {
            this.changeColor();
            this.bonusMode = false;
            this.centralControl = this.isCentralControl();
            this.flipList = flipList;
            this.placeid = id;
            this.placeKomaAnime();
            return;
        }
        this.dispMsg();
    }

    this.placeKomaAnime = function() {
        var cobj = document.getElementById("animekoma");
        cobj.display = "none";
        var c = (this.color == 1) ? this.COLOR1 : this.COLOR2;
        var html = "<img src='" + c + "'/>";
        cobj.innerHTML = html;
        cobj.style.position = "absolute";
        animeCtrl.addObject(
            cobj, this.startPosList[this.color - 1], getPosition(this.placeid), this.animeTimes());
    }

    this.placeKomaHandler = function() {
        if (this.color == 1) {
            this.placeKoma(this.placeid, this.flipList);
            if (this.isTsubuyaki()) {
                var p = calPoint(this.flipList, this.placeid);
                if (this.isCentralGame) {
                    p = p / 2;
                }
                if (p >= 20) {
                    this.addMsg("やられた。もう駄目だ。");
                } else if (p >= 10) {
                    this.addMsg("痛いところに置いてきましたね");
                }
            }
            if ( (! this.centralControl) && this.isCentralControl() ) {
                this.addMsg("中央占拠ボーナスで一ヶ所を奪えます");
                var placableList = makeBonusList(this.color, this.cell);
                if (placableList) {
                    this.bonusMode = true;
                    this.changePlacableColor(placableList);
                } else {
                    this.addMsg("でも、あなたは置けるところがないんでパスです");
                }
            }
            if (! this.bonusMode) {
                this.color = (this.color % 2) + 1;
                this.dispCount();
                this.dispMsg("app.placeOne()");
                return;
            }
        } else {
            var id = this.placeid;
            var flipList = this.flipList;
            var centralControl = this.centralControl;
            this.placeKoma(id, flipList);
            if ( (! centralControl) && this.isCentralControl() ) {
                this.addMsg("中央占拠ボーナスで一ヶ所を奪えます");
                var placableList = makeBonusList(this.color, this.cell);
                if (placableList) {
                    this.dispMsg("app.placeBonus()");
                    this.dispCount();
                    return;
                } else {
                    this.addMsg("でも、私はは置けるところがないんでパスです");
                }
            }
            this.color = (this.color % 2) + 1;
            placableList = makePlacableList(this.color, this.cell)
            if (! placableList) {
                this.color = (this.color % 2) + 1;
                placableList = makePlacableList(this.color, this.cell);
                if (placableList) {
                    this.addMsg("あなたは置けるところがないんでパスです");
                    this.dispMsg("app.placeOne()");
                    this.dispCount();
                    return;
                }
            }
        }
        if (placableList) {
            this.changePlacableColor(placableList);
        } else {
            this.dispCount();
            var msg = "ゲーム終了\n";
            this.gameEnd = true;
            if (this.countList[1] > this.countList[2]) {
                msg = msg + "あなたの勝ちです!";
            } else if (this.countList[1] < this.countList[2]) {
                msg = msg + "あなたの負けです!";
            } else {
                msg = msg + "引き分けです";
            }
            this.addMsg(msg);
        }
        this.dispCount();
        this.dispMsg();
    }

    this.placeOne = function() {
        var placableList = makePlacableList(this.color, this.cell);
        if (placableList) {
            // コンピュータの番
            this.placeid = this.thinkPlace(placableList);
            this.flipList = makeFlipList(this.placeid, this.color, this.cell);
            this.centralControl = this.isCentralControl();
            this.placeKomaAnime();
            return;
        } else {
            this.color = (this.color % 2) + 1;
            placableList = makePlacableList(this.color, this.cell);
            if (placableList) {
                this.addMsg("私は置けるところがないんでパスします");
            }
        }
        if (placableList) {
            this.changePlacableColor(placableList);
        } else {
            this.dispCount();
            var msg = "ゲーム終了\n";
            this.gameEnd = true;
            if (this.countList[1] > this.countList[2]) {
                msg = msg + "あなたの勝ちです!";
            } else if (this.countList[1] < this.countList[2]) {
                msg = msg + "あなたの負けです!";
            } else {
                msg = msg + "引き分けです";
            }
            this.addMsg(msg);
        }
        this.dispCount();
        this.dispMsg();
    }

    this.placeBonus = function() {
        var placableList = makeBonusList(this.color, this.cell);
        if (placableList) {
            // コンピュータの番
            var id = this.thinkPlace(placableList);
            this.flipList = makeFlipList(id, this.color, this.cell);
            this.centralControl = this.isCentralControl();
            this.placeid = id;
            this.placeKomaAnime();
            return;
        } else {
            this.color = (this.color % 2) + 1;
            placableList = makePlacableList(this.color, this.cell);
            if (placableList) {
                this.addMsg("私は置けるところがないんでパスします");
            }
        }
        if (placableList) {
            this.changePlacableColor(placableList);
        } else {
            this.dispCount();
            var msg = "ゲーム終了\n";
            this.gameEnd = true;
            if (this.countList[1] > this.countList[2]) {
                msg = msg + "あなたの勝ちです!";
            } else if (this.countList[1] < this.countList[2]) {
                msg = msg + "あなたの負けです!";
            } else {
                msg = msg + "引き分けです";
            }
            this.addMsg(msg);
        }
        this.dispCount();
        this.dispMsg();
    }

    // 置ける場所のリストを作る
    function makePlacableList(c, cell) {
        var result = new Array();
        for (var x = 1; x <= 8; x++) {
            for (var y = 1; y <= 8; y++) {
                var id = makeId(x, y);
                if (cell[id]) {
                    continue;
                }
                var flist = makeFlipList(id, c, cell);
                if (flist.length > 0) {
                    result[id] = flist;
                    result.length = result.length + 1;
                }
            }
        }
        if (result.length > 0) {
            return result;
        }
        return null;
    }

    // ボーナスで置ける場所のリストを作成する。
    function makeBonusList(c, cell) {
        var result = new Array();
        for (var x = 1; x <= 8; x++) {
            for (var y = 1; y <= 8; y++) {
                var id = makeId(x, y);
                if ( (cell[id]) && (cell[id] != c) ) {
                    var flist = makeFlipList(id, c, cell);
                    result[id] = flist;
                    result.length = result.length + 1;
                }
            }
        }
        if (result.length > 0) {
            return result;
        }
        return null;
    }

    // 駒の数を数える
    this.countKoma = function() {
        var result = new Object();
        result[1] = 0;
        result[2] = 0;
        for (var x = 1; x <= 8; x++) {
            for (var y = 1; y <= 8; y++) {
                var id = makeId(x, y);
                var c = this.cell[id];
                if (c) {
                    if (result[c]) {
                        result[c] = result[c] + 1;
                    } else {
                        result[c] = 1;
                    }
                }
            }
        }

        return result;
    }

    // 得点を数える
    this.countPoint = function() {
        var result = new Object();
        result[1] = 0;
        result[2] = 0;
        for (var x = 1; x <= 8; x++) {
            for (var y = 1; y <= 8; y++) {
                var id = makeId(x, y);
                var point = getPoint(id);
                var c = this.cell[id];
                if (c) {
                    if (result[c]) {
                        result[c] = result[c] + point;
                    } else {
                        result[c] = point;
                    }
                }
            }
        }

        return result;
    }

    // 得点を表示する
    this.dispCount = function() {
        var e1 = document.getElementById("count1");
        var e2 = document.getElementById("count2");
        this.countList = this.countPoint();
        e1.innerHTML = this.countList[1];
        e2.innerHTML = this.countList[2];
    }

    // 置く場所を考える。
    this.thinkPlace = function(placableList) {
        var max = -9999;
        var maxList = null;
        var oc = (this.color % 2) + 1;
        var basePoint = 0;
        var plist = makePlacableList(oc, this.cell);
        if (plist) {
            basePoint += plist.length * 2;
        }
        basePoint -= placableList.length;
        for (id in placableList) {
            point = basePoint + calPoint(placableList[id], id);
            point += this.thinkNext(id, placableList[id]);

            if (point > max) {
                max = point;
                maxList = new Array();
                maxList.push(id);
            } else if (point == max) {
                maxList.push(id);
            }
        }

        maxList  = randomArray(maxList);
        if (this.isTsubuyaki()) {
            if (this.isCentralGame) {
                max = max / 2;
            }
            if (max <= -15) {
                this.addMsg("駄目だ、こりゃ。負けだ。");
            } else if (max <= 0) {
                this.addMsg("こんなとこ、置きたくないんだけどな");
            } else if (max <= 5) {
                this.addMsg("あんまりよくないなあ");
            } else if (max <= 10) {
                this.addMsg("ふつうかな");
            } else if (max <= 20) {
                this.addMsg("まあまあってとこだね");
            } else if (max <= 30) {
                this.addMsg("ラッキーだな。いい所に置けるよ。");
            } else {
                this.addMsg("この勝負もらった！");
            }
        }

        return maxList[0];
    }

    // 終了処理
    this.clickRestart = function() {
        if (!(this.gameEnd) ) {
            if (confirm("現在のゲームを中断して、最初からやり直しますか？") ) {
                this.restart();
            }
        } else {
            this.restart();
        }
    }

    this.restart = function() {
        this.placeEnable = false;
        var subwin = document.getElementById("subwin");
        subwin.style.display = "inline";
        var googlead = document.getElementById("googlead");
        googlead.style.display = "inline";
    }

    function getPoint(id) {
        var point = 1;
        if (app.isCentralGame) {
            var x = parseInt(id.substring(1,2));
            var y = parseInt(id.substring(2,3));
            if (4 <= x && x <= 5 && 4 <= y && y <= 5) {
                point = 10;
            } else if (3 <= x && x <= 6 && 3 <= y && y <= 6) {
                point = 5;
            } else if (2 <= x && x <= 7 && 2 <= y && y <= 7) {
                point = 3;
            }
        }
        return point;
    }

    // 角（プラス対象）
    function isKado(id) {
        if (id == "c11") {
            return true;
        } else if (id == "c18") {
            return true;
        } else if (id == "c81") {
            return true;
        } else if (id == "c88") {
            return true;
        }
        return false;
    }

    // 角の斜め隣（マイナス対象）
    function isKadoNaname(id) {
        if (id == "c22") {
            return true;
        } else if (id == "c27") {
            return true;
        } else if (id == "c72") {
            return true;
        } else if (id == "c77") {
            return true;
        }
        return false;
    }

    // 角の横（マイナス対象）
    function isKadoYoko(id) {
        if (id == "c12") {
            return true;
        } else if (id == "c21") {
            return true;
        } else if (id == "c71") {
            return true;
        } else if (id == "c82") {
            return true;
        } else if (id == "c78") {
            return true;
        } else if (id == "c87") {
            return true;
        } else if (id == "c17") {
            return true;
        } else if (id == "c28") {
            return true;
        }
        return false;
    }

    // 端
    function isHaji(id) {
        var loc = getLocationById(id);
        if ( (loc.x != 1) && (loc.x != 8) && (loc.y != 1) && (loc.y != 8) ) {
            return false;
        }
        return true;
    }

    // 端の１つ内側
    function isHajiTonari(id) {
        var loc = getLocationById(id);
        if ( (loc.x != 2) && (loc.x != 7) && (loc.y != 2) && (loc.y != 7) ) {
            return false;
        }
        return true;
    }

    // ある場所に駒を置いたときの基本ポイントの計算
    function calPoint(flipList, id) {
        var point  = calPointId(id);
        for (i = 0; i < flipList.length; i++) {
            point += calPointId(flipList[i]);
        }
        return point;
    }

    // １セルの基本ポイントを数える
    function calPointId(id) {
        point = 0;
        if (isKado(id) ) {
            point = 30;
        } else if (isKadoNaname(id) ) {
            point = -10;
        } else if (isKadoYoko(id) ) {
            point = -5;
        } else if (isHaji(id) ) {
            point = 5;
        } else if (isHajiTonari(id) ) {
            point = -2;
        } else {
            point = 1;
        }
        point += getPoint(id) - 1;

        return point;
    }

    // １手先を考える
    this.thinkNext = function(id, flipList) {
        var cell2 = new Object();
        cell2.length = 0;
        for (var c in this.cell) {
            cell2[c] = this.cell[c];
            cell2.length += 1;
        }
        cell2[id] = this.color;
        cell2.length += 1;
        for (var i = 0; i < flipList.length; i++) {
            c = flipList[i];
            cell2[c] = this.color;
        }

        // 相手の次の手はマイナスポイント
        var oc = (this.color % 2) + 1;
        var plist = makePlacableList(oc, cell2);
        var point = 0;
        var maxid = null;
        if (plist) {
            var max = -999;
            for (var i in plist) {
                var list = plist[i];
                var p = calPoint(list, i);
                if (max < p) {
                    max = p;
                    maxid = i;
                }
            }
            point -= max;

            // 相手の次の手の選択肢もマイナスポイント
            point -= (plist.length * 2);
        } else {
            // 相手が置くところがないとプラスポイント
            point = 30;
        }

        // 相手が裏返せない場所はプラス点
        var unflipableList = makeUnflipableList(plist, cell2, this.color);
        if (this.isCentralGame) {
            point += unflipableList.length * 2;
        } else {
            point += unflipableList.length * 0.5;
        }

        plist = makePlacableList(this.c, cell2);
        // 自分が裏返せない場所はマイナス点
        var unflipableList = makeUnflipableList(plist, cell2, oc);
        if (this.isCentralGame) {
            point -= unflipableList.length * 5;
        } else {
            point -= unflipableList.length * 0.5;
        }
        if (plist) {
            // 次の自分の手の選択肢はプラスポイント
            point += plist.length;
        } else {
            // 次に置くところがないとマイナスポイント
            point -= 5;
        }

        return point;
    }

    // ひっくり返せない場所のリストを作成する
    function makeUnflipableList(placableList, cell, c) {
        var flipableList = new Object();
        for (var id in placableList) {
            var flipList = placableList[id];
            for (var i = 0; i < flipList.length; i++) {
                flipableList[flipList[i]] = true;
            }
        }

        var result = new Array();
        for (var x = 1; x <= 8; x++) {
            for (var y = 1; y <= 8; y++) {
                var id = makeId(x, y);
                if (cell[id] == c) {
                    if (! flipableList[id]) {
                        result.push(id);
                    }
                }
            }
        }
        return result;
    }

    this.dispMsg = function(func) {
        var e = document.getElementById("msg");
        if (this.msgList.length == 0) {
            if (! this.gameEnd) {
                e.style.display = "none";
                this.placeEnable = true;
            }
            if (func) {
                window.setTimeout(func, 500);
            }
            return false;
        }
        var msg = this.msgList.shift();
        e.innerHTML = "<table><tr><td class=\"msg\">" + msg + "</td></tr></table>";
        e.style.display = "inline";
        if (func) {
            window.setTimeout("app.dispMsg(\"" + func + "\")", 500);
        } else {
            window.setTimeout("app.dispMsg()", 500);
        }
        return true;
    }

    this.addMsg = function(msg) {
        this.msgList.push(msg);
    }

    // id -> Location 変換
    function Location(x, y) {
        this.x = x;
        this.y = y;
        this.isEnable = function() {
            if (this.x < 1) {
                return false;
            } else if (this.x > 8) {
                return false;
            } else if (this.y < 1) {
                return false;
            } else if (this.y > 8) {
                return false;
            } else {
                return true;
            }
        }

        // 隣を取得する
        this.getAjust = function(dir) {
            if (dir == 1) {
                return new Location(this.x -1, this.y -1) ;
            } else if (dir == 2) {
                return new Location(this.x, this.y -1) ;
            } else if (dir == 3) {
                return new Location(this.x + 1, this.y -1) ;
            } else if (dir == 4) {
                return new Location(this.x + 1, this.y) ;
            } else if (dir == 5) {
                return new Location(this.x + 1, this.y + 1) ;
            } else if (dir == 6) {
                return new Location(this.x, this.y + 1) ;
            } else if (dir == 7) {
                return new Location(this.x - 1, this.y + 1) ;
            } else if (dir == 8) {
                return new Location(this.x - 1, this.y) ;
            }
            return null;
        }

        // IDを取得する
        this.getId = function() {
            return makeId(this.x, this.y);
        }

        // 文字列に変換する
        this.toString = function() {
            return "x = " + this.x + ", y = " + this.y;
        }
        return this;
    }

    this.changeColor = function() {
        var list = document.getElementsByTagName("td");
        var color1 = "#aaaaaa";
        var color2 = "#44aa00";
        var color3 = "#99aa00";
        var color4 = "#444444";
        if (! this.isCentralGame) {
            color1 = color2 = color3 = color4 = "#007700";
        }

        for (var ix = 0; ix < list.length; ix++) {
            var e = list[ix];
            if (e.className == "z1") {
                e.style.backgroundColor = color1;
            } else if (e.className == "z2") {
                e.style.backgroundColor = color2;
            } else if (e.className == "z3") {
                e.style.backgroundColor = color3;
            } else if (e.className == "z4") {
                e.style.backgroundColor = color4;
            }
        }
    }

    this.changePlacableColor = function(placableList) {
        var list = document.getElementsByTagName("td");
        var color1b = "#aaaaaa";
        var color2b = "#44aa00";
        var color3b = "#99aa00";
        var color4b = "#444444";
        var color1 = "#eeeeee";
        var color2 = "#44ee00";
        var color3 = "#ccee00";
        var color4 = "#888888";
        if (! this.isCentralGame) {
            color1 = color2 = color3 = color4 = "#44aa44";
            color1b = color2b = color3b = color4b = "#007700";
        }

        for (var ix = 0; ix < list.length; ix++) {
            var e = list[ix];
            if (e.className == "z1") {
                e.style.backgroundColor = color1b;
            } else if (e.className == "z2") {
                e.style.backgroundColor = color2b;
            } else if (e.className == "z3") {
                e.style.backgroundColor = color3b;
            } else if (e.className == "z4") {
                e.style.backgroundColor = color4b;
            }
        }

        for (var id in placableList) {
            var e = document.getElementById(id);
            if (e.className == "z1") {
                e.style.backgroundColor = color1;
            } else if (e.className == "z2") {
                e.style.backgroundColor = color2;
            } else if (e.className == "z3") {
                e.style.backgroundColor = color3;
            } else if (e.className == "z4") {
                e.style.backgroundColor = color4;
            }
        }
    }

    // bodyにマウスが乗った時のイベント処理
    this.overBody = function() {
        if (this.infoIcon) {
            this.infoIcon.start(true);
        }
    }

    // マウスカーソルがbodyから出た時のイベント処理
    this.outBody = function() {
        if (this.infoIcon) {
            this.infoIcon.start(false);
        }
    }

    // 表面を表示する。
    this.dispOmote = function() {
        if (window.widget) {
            widget.prepareForTransition("ToFront");
        }
        this.pause = false;
        document.getElementById("ura").style.display = "none";
        document.getElementById("omote").style.display = "block";
        if (window.widget) {
            setTimeout("widget.performTransition();", 0);
        }
    }

    // 裏面を表示する
    this.dispUra = function() {
        if (window.widget) {
            widget.prepareForTransition("ToBack");
        }
        this.pause = true;
        document.getElementById("omote").style.display = "none";
        document.getElementById("ura").style.display = "block";
        infoout("ibuttonback");
        if (window.widget) {
            setTimeout("widget.performTransition();", 0);
        }
    }

    return this;
}

// iアイコン上にマウスカーソルが来た時のイベント処理
function infoover(id) {
    document.getElementById(id).style.display = "block";
}

// iアイコン上からマウスカーソルが離れた時のイベント処理
function infoout(id) {
    document.getElementById(id).style.display = "none";
}

// widget表示時のイベント処理（pauseを解除）
function onshow() {
    app.pause = false;
}

// widget非表示時のイベント処理(pauseする)
function onhide() {
    app.pause = true;
}

function stopGame() {
    app.dispOmote();
    app.gameEnd = true;
    app.restart();
}

// 駒の表示位置を算出する。
function getPosition(id) {
    var x = parseInt(id.substring(1,2));
    var y = parseInt(id.substring(2,3));
    var top = x * 36 + 3;
    var left = y * 36 - 18;

    var pos = new Position(top, left);
    return pos;
}

app = new CentralRiversi();

